/* wipemem multiboot executable - David A. Madore - Public Domain */

	.text

	.globl	_start

_start:
	jmp	mb_entry

	.align	4, 0x90
mb_header:
	mb_magic = 0x1badb002	/* Multiboot magic number */
	mb_flags = 3		/* Multiboot flags (page align, mem info) */
	.long	mb_magic
	.long	mb_flags
	.long	-(mb_magic+mb_flags)

mb_entry:
	mov	$stack_end, %esp
	push 	%ebx
	push	%eax
	pushf
	pop	%eax
	and	$0xffc00000, %eax
	push	%eax
	popf
	call	boot_main
out:

	.globl	stop
	.type	stop, @function
stop:	hlt
	jmp	stop
	.size	stop, .-stop


	.section .stack, "wa", @nobits

	.align	64
stack:	.fill	0x10000
	.size	stack, .-stack
stack_end:


	.section .paging, "wa", @nobits

	.align	4096

	/* Page directory */
	.globl	pd
pd:	.fill	0x1000
	.type	pd, @object
	.size	pd, .-pd

	/* Page directory pointer table */
	.globl	pdpt
pdpt:	.fill	0x20
	.type	pdpt, @object
	.size	pdpt, .-pdpt
