/* wipemem multiboot executable - David A. Madore - Public Domain */
/* machine.c - machine functions */

#include <stdint.h>

#include "machine.h"

void
outb (uint16_t port, uint8_t val)
{
  asm volatile ("out %0, %1" : : "a" (val), "d" (port));
}

void
reboot (void)
{
  asm volatile ("wbinvd");
  *(volatile unsigned short *)0x472 = 0x1234;  /* Request "warm" reboot from BIOS */
  asm volatile ("wbinvd");
  for (volatile long stupidloop=0 ; stupidloop<1000000L ; stupidloop++ )
    ;  /* Give the cache a chance to be drained (is this necessary?) */
#if 1
  outb (0xcf9, 0x0);  /* Prepare for reset */
  outb (0xcf9, 0x4);  /* Now do it! */
  for (volatile long stupidloop=0 ; stupidloop<1000000L ; stupidloop++ )
    ;  /* Give the chipset a chance to reboot us (is this necessary?) */
#endif
  outb (0x64, 0xfe);  /* Failed?  Try to reboot through keyboard controller */
}
