/* wipemem multiboot executable - David A. Madore - Public Domain */
/* multiboot.h - declare multiboot specification structures */

#ifndef _MULTIBOOT_H
#define _MULTIBOOT_H

struct mod_info {
  uint32_t mod_start;
  uint32_t mod_end;
  unsigned char *string;
  uint32_t reserved;
};

struct mmap_info {
  uint32_t size;
  uint64_t base_addr;
  uint64_t length;
  uint32_t type;
};

struct mb_info {
  uint32_t flags;
  uint32_t mem_lower;
  uint32_t mem_upper;
  uint8_t boot_device[4];
  unsigned char *cmdline;
  uint32_t mods_count;
  struct mod_info *mods_addr;
  union {
    struct {
      uint32_t tabsize;
      uint32_t strsize;
      uint32_t addr;
      uint32_t reserved;
    } aout;
    struct {
      uint32_t num;
      uint32_t size;
      uint32_t addr;
      uint32_t shndx;
    } elf;
  } syms;
  uint32_t mmap_length;
  struct mmap_info *mmap_addr;
  uint32_t drives_length;
  uint32_t drives_addr;
  uint32_t config_table;
  uint32_t boot_loader_table;
  uint32_t apm_table;
  uint32_t vbe_control_info;
  uint32_t vbe_mode_info;
  uint32_t vbe_mode;
  uint32_t vbe_interface_seg;
  uint32_t vbe_interface_off;
  uint32_t vbe_interface_len;
};

#endif
